<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
      </template>
      <template slot="transferStatus" slot-scope="{row}">
        <el-tag v-if="row.transferStatus === 18" plain type="info">待处理</el-tag>
        <el-tag v-if="row.transferStatus === 19" plain type="warning">处理中</el-tag>
        <el-tag v-if="row.transferStatus === 20" plain type="success">转账成功</el-tag>
        <el-tag v-if="row.transferStatus === 21" plain type="danger">失败</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bussinessmng/bussinesstransferorder";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          delBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "商户请求号",
              prop: "requestNo",
            },
            {
              label: "转出方商户",
              prop: "fromMerchantNo",
              type: "select",
              labelWidth: 120,
              dicUrl: "/api/cyzh-guosen/bussiness/listBussiness?size=500&registerStatus=200",
              props:{
                label: "name",
                value: "merchantNo"
              },
              addDisplay: false,
              editDisplay: false,
              viewDisplay: true
            },
            {
              label: "转入方商户",
              prop: "toMerchantNo",
              type: "select",
              labelWidth: 120,
              dicUrl: "/api/cyzh-guosen/bussiness/listBussiness?size=500&registerStatus=200",
              props:{
                label: "name",
                value: "merchantNo"
              },
              addDisplay: false,
              editDisplay: false,
              viewDisplay: true
            },
            {
              label: "转账金额",
              prop: "orderAmount",
            },
            {
              label: "手续费",
              prop: "fee",
            },
            {
              label: "扣账金额",
              prop: "debitAmount",
            },
            {
              label: "入账金额	",
              prop: "receiveAmount",
            },
            {
              label: "完成时间",
              prop: "finishTime",
              width: 150,
              search:true,
            },
            {
              label: "转账状态",
              prop: "transferStatus",
              type: "select",
              slot: true,
              search: true,
              dicData: [
                {
                  label: "待处理",
                  value: 18
                },
                {
                  label: "正在处理",
                  value: 19
                },
                {
                  label: "转账成功",
                  value: 20
                },
                {
                  label: "转账失败",
                  value: 21
                }
              ],
            },
            {
              label: "创建时间",
              prop: "createTime",
              type: "date",
              addDisplay: false,
              editDisplay: false,
              valueFormat: "yyyy-MM-dd HH:mm:ss"
            },
            {
              label: "更新时间",
              prop: "updateTime",
              type: "date",
              addDisplay: false,
              editDisplay: false,
              valueFormat: "yyyy-MM-dd HH:mm:ss"
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussinesstransferorder_add, false),
          viewBtn: this.vaildData(this.permission.bussinesstransferorder_view, false),
          delBtn: this.vaildData(this.permission.bussinesstransferorder_delete, false),
          editBtn: this.vaildData(this.permission.bussinesstransferorder_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
